#include <bits/stdc++.h>
typedef int_fast64_t lli;
using namespace std;
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    lli n;
    cin >> n;
    vector<lli> a(n);
    vector<pair<lli, lli> > ans;
    for(lli i = 0, x; i < n; i++) cin >> a[i];
    for(lli i = 0; i < n; i++)
    {
        for(lli j = 0; j < n-i-1; j++)
            if(a[j] > a[j+1])
            {
                ans.emplace_back(j+1, j+2);
                swap(a[j], a[j+1]);
            }
    }
    cout << ans.size() << endl;
    for(auto& x : ans) cout << x.first << " " << x.second << endl;
}
